#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int SIZE = 2 * 1e5;
vector<int> graph[SIZE];
int max_depth[SIZE], ends_cnt;

void dfs(int v, int d)
{
	max_depth[v] = d;
	if (graph[v].size() == 0)
		ends_cnt++;
	for (int i = 0; i < graph[v].size(); i++)
	{
		dfs(graph[v][i], d + 1);
		max_depth[v] = max(max_depth[v], max_depth[graph[v][i]]);
	}
}

int main()
{
	int n, m, par, max1 = 0, max2 = 0;

	cin >> n >> m;
	for (int i = 1; i < n; i++)
	{
		cin >> par;
		graph[par - 1].push_back(i);
	}
	dfs(0, 0);
	for (int i = 0; i < graph[0].size(); i++)
	{
		if (max1 < max_depth[graph[0][i]])
		{
			max2 = max1;
			max1 = max_depth[graph[0][i]];
		}
		else if (max2 < max_depth[graph[0][i]])
			max2 = max_depth[graph[0][i]];
	}
	if (ends_cnt != 1)
		cout << (max1 + 1) * (2 * m - 1) + max2;
	else
		cout << (max1 + 1) * m;
}