#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int SIZE = 2 * 1e5;
vector<int> graph[SIZE];
int max_dist[SIZE], depth[SIZE];

void dfs(int v, int d)
{
	max_dist[v] = 0;
	depth[v] = d;
	for (auto u : graph[v])
	{
		dfs(u, d + 1);
		max_dist[v] = max(max_dist[v], max_dist[u] + 1);
	}
}

int main()
{
	long long int n, m, par, max1 = -1, max2 = -1, ans = 0;

	cin >> n >> m;
	for (int i = 1; i < n; i++)
	{
		cin >> par;
		graph[par - 1].push_back(i);
	}
	dfs(0, 1);
	for (int i = 0; i < n; i++)
	{
		if (graph[i].size() < 2)
		{
			ans = max(ans, (depth[i] + max_dist[i]) * m);
			continue;
		}
		max1 = 0;
		max2 = 0;
		for (auto u : graph[i])
		{
			if (max_dist[u] >= max1)
			{
				max2 = max1;
				max1 = max_dist[u];
			}
			else if (max_dist[u] > max2)
				max2 = max_dist[u];
		}
		//cout << i << ' ' << max1 << ' ' << max2 << ' ' << depth[i] << endl;
		ans = max(ans, (depth[i] + max1 + 1) * (2 * m - 1) + max2 + 1);
	}
	cout << ans;
}